<h1>Schema JSON-LD Markup for Google Rich Results</h1><h3>WPSSO Add-on</h3>

<table>
<tr><th align="right" valign="top" nowrap>Plugin Name</th><td>WPSSO Schema JSON-LD Markup</td></tr>
<tr><th align="right" valign="top" nowrap>Summary</th><td>Google Rich Results and Structured Data for Articles, Carousels, Events, FAQ Pages, How-Tos, Local SEO, Products, Recipes, Ratings, Reviews, and more.</td></tr>
<tr><th align="right" valign="top" nowrap>Stable Version</th><td>3.2.0</td></tr>
<tr><th align="right" valign="top" nowrap>Requires PHP</th><td>5.6 or newer</td></tr>
<tr><th align="right" valign="top" nowrap>Requires WordPress</th><td>4.2 or newer</td></tr>
<tr><th align="right" valign="top" nowrap>Tested Up To WordPress</th><td>5.4</td></tr>
<tr><th align="right" valign="top" nowrap>Tested Up To WooCommerce</th><td>4.0.1</td></tr>
<tr><th align="right" valign="top" nowrap>Contributors</th><td>jsmoriss</td></tr>
<tr><th align="right" valign="top" nowrap>License</th><td><a href="https://www.gnu.org/licenses/gpl.txt">GPLv3</a></td></tr>
<tr><th align="right" valign="top" nowrap>Tags / Keywords</th><td>schema.org, rich snippets, structured data, amp, woocommerce, image seo, video seo, news seo, schema, rich results, knowledge graph, rating, review, recipe, event, product</td></tr>
</table>

<h2>Description</h2>

<p style="margin:0;"><img class="readme-icon" src="https://surniaulula.github.io/wpsso-schema-json-ld/assets/icon-256x256.png"></p>

<p><strong>Supports over 495 different Schema types and sub-types:</strong></p>

<p>Google Rich Results and Structured Data for Articles, Carousels (aka Item Lists), Claim Reviews, Events, FAQ Pages, How-Tos, Images, Local Business / Local SEO, Organizations, Products, Ratings, Recipes, Restaurants, Reviews, Videos, and more.</p>

<p>Uses filters to dynamically (and automatically) create Schema markup, allowing the WPSSO Schema JSON-LD Markup add-on to provide an almost unlimited number of Schema types, children sub-types, and properties inherited from each parent type (for example, Restaurant is a sub-type of Food Establishment, which is a sub-type of Local Business, which is sub-type of <em>both</em> Organization <em>and</em> Place, which are both sub-types of Thing).</p>

<p><strong>Uses your existing WordPress content, plugin and service API data:</strong></p>

<p>There's no need to manually re-create descriptions, titles, product information, re-select images / videos, etc.</p>

<p>This add-on provides accurate and comprehensive Schema JSON-LD markup for posts, pages, custom post types, terms (category, tags, etc.), custom taxonomies, user profile pages, search result pages, archive pages, and Accelerated Mobile Pages (AMP) pages &mdash; including image SEO, video SEO, local business, organization, publisher, person, author and co-authors, extensive e-Commerce product markup, product variations, product ratings, aggregate ratings, reviews, recipe information, event details, collection pages, profile pages, search pages, FAQ pages, item lists for <a href="https://developers.google.com/search/docs/guides/mark-up-listings">Google's Carousel Rich Results</a>, and much more.</p>

<p><strong>Most complete Schema JSON-LD markup for WooCommerce products:</strong></p>

<p>The WooCommerce plugin is known to provide incomplete Schema markup for Google. The <a href="https://wpsso.com/extend/plugins/wpsso/">WPSSO Core Premium plugin</a> (required for WooCommerce integration) and its WPSSO Schema JSON-LD add-on provide a far better solution by offering complete Facebook / Pinterest Product meta tags and Schema Product markup for Google Rich Results (previously known as Rich Snippets) &mdash; including additional product images, product variations, product attributes (brand, color, condition, EAN, dimensions, GTIN-8/12/13/14, ISBN, material, MPN, size, SKU, weight, etc), product reviews, product ratings, sale start / end dates, sale prices, pre-tax prices, VAT prices, and much, much more.</p>

<p><strong>Fixes all Google Search Console / Structured Data Testing Tool errors:</strong></p>

<ul>
<li>A value for the headline field is required.</li>
<li>A value for the image field is required.</li>
<li>A value for the logo field is required.</li>
<li>A value for the publisher field is required.</li>
<li>The aggregateRating field is recommended.</li>
<li>The brand field is recommended.</li>
<li>The headline field is recommended.</li>
<li>The image field is recommended.</li>
<li>The mainEntityOfPage field is recommended.</li>
<li>The review field is recommended.</li>
<li>This Product is missing a global identifier (e.g. isbn, mpn or gtin8).</li>
<li>No global identifier provided (e.g. gtin mpn isbn).</li>
<li>Not a known valid target type for the itemReviewed property.</li>
<li>And more...</li>
</ul>

<p>Some Schema property values may require data from <a href="https://wpsso.com/extend/plugins/wpsso/">WPSSO Core Premium</a> supported 3rd party plugins and service APIs.</p>

<p>Google regularly updates and changes their Schema markup requirements - WPSSO JSON Premium customers can also <a href="https://surniaulula.com/support/">open a Premium support ticket for assistance</a> with any new Google testing tool errors.</p>

<h3>Users Love the WPSSO JSON Add-on</h3>

<p>&#x2605;&#x2605;&#x2605;&#x2605;&#x2605; &mdash; "Forget everything else this is the best schema plugin - Sincerely, we bought other plugins that we had to abandon due to the lack of important features, but with this [WPSSO JSON] we get all that we need - and our schema has more features than the competition!" - <a href="https://wordpress.org/support/topic/forget-everything-else-this-is-the-best-schema-plugin/">zuki305</a></p>

<p>&#x2605;&#x2605;&#x2605;&#x2605;&#x2605; &mdash; "Tried three other plugins before this one - for our Woocommerce site, this was by far the best one. Thanks!" - <a href="https://wordpress.org/support/topic/tried-three-other-plugins-before-this-one/">EntoMarket</a></p>

<p>&#x2605;&#x2605;&#x2605;&#x2605;&#x2605; &mdash; "Crazy good! This plugin is one of my favorites! JS aggressively develops and improves this suite of plugins, continuously improving and adding features – with great customer support to boot! Highly recommended to improve your SEO for all kinds of JSON schemas!" - <a href="https://wordpress.org/support/topic/crazy-good-1/">mikegoubeaux</a></p>

<p>&#x2605;&#x2605;&#x2605;&#x2605;&#x2605; &mdash; "This plugin is heaven sent. I know little about SSO and this has taken care of everything. The support makes this an even better plugin to have. Keep up the great work!" - <a href="https://wordpress.org/support/topic/best-plugin-and-support-10/">kevanchetty</a></p>

<h3>WPSSO JSON Standard Features</h3>

<ul>
<li><p>Extends the features of the WPSSO Core plugin.</p></li>
<li><p>Provides accurate and comprehensive Schema JSON-LD markup for Google Rich Results / Rich Snippets with Structured Data.</p></li>
<li><p>Provides complete Schema ImageObject SEO markup with image information from the WordPress Media Library (name, alternateName, alternativeHeadline, caption, description, fileFormat, uploadDate, and more).</p></li>
<li><p>Provides complete Schema VideoObject SEO markup with video information from WPSSO Core Premium service APIs (Facebook, Slideshare, Soundcloud, Vimeo, Wistia, YouTube).</p></li>
<li><p>Provides Schema Article AMP 1:1, 4:3, and 16:9 images for mobile Google Rich Results (see the <a href="https://developers.google.com/search/docs/data-types/article#amp-sd">Google Article AMP structured data guidelines</a> for details).</p></li>
<li><p>Provides Schema FAQPage and Question / Answer markup for the <a href="https://wordpress.org/plugins/wpsso-faq/">WPSSO FAQ Manager</a> add-on.</p></li>
<li><p>Includes Schema JSON-LD scripts from shortcodes and WordPress editor blocks in the Schema CreativeWork type and sub-types.</p></li>
<li><p>Built-in support for <a href="https://wordpress.org/plugins/amp/">AMP</a>, <a href="https://wordpress.org/plugins/better-amp/">Better AMP</a>, and <a href="https://wordpress.org/plugins/accelerated-mobile-pages/">AMP for WP</a> plugins.</p></li>
<li><p>Includes contributor markup for <a href="https://wordpress.org/plugins/co-authors-plus/">Co-Authors Plus</a> authors and guest authors (<a href="https://wpsso.com/">WPSSO Core Premium plugin</a> required).</p></li>
<li><p>Supports additional custom product information and WooCommerce product attributes from the WPSSO Core Premium plugin:</p>

<ul>
<li>Product Availability</li>
<li>Product Brand</li>
<li>Product Category</li>
<li>Product Color</li>
<li>Product Condition</li>
<li>Product Depth</li>
<li>Product GTIN-14</li>
<li>Product GTIN-13/EAN</li>
<li>Product GTIN-12/UPC</li>
<li>Product GTIN-8</li>
<li>Product GTIN</li>
<li>Product ISBN</li>
<li>Product Length</li>
<li>Product Material</li>
<li>Product MPN</li>
<li>Product SKU</li>
<li>Product Price</li>
<li>Product Size</li>
<li>Product Target Gender</li>
<li>Product Weight</li>
<li>Product Width</li>
<li>Product Volume</li>
</ul></li>
<li><p>WooCommerce product variations from the WPSSO Core Premium plugin are grouped by currency and added as Schema AggregateOffer for Google's Rich Results (includes the product variation group high price, low price, and currency).</p></li>
<li><p>Fixes common Google testing tool warnings like "aggregateRating field is recommended" and "review field is recommended".</p></li>
<li><p>Fixes Google testing tool warnings for supported WPSSO Core Premium e-commerce products, like "brand field is recommended", "missing a global identifier", etc.</p></li>
</ul>

<h3>WPSSO JSON Premium Features</h3>

<p>The Standard version is designed to satisfy the requirements of most standard WordPress sites / blogs. If your site requires additional customizable Schema properties for products, events, places / locations, recipes, etc., then you may want the Premium version for those additional features.</p>

<ul>
<li><p>Includes additional customizable option values in the Document SSO metabox:</p>

<ul>
<li>All Schema Types

<ul>
<li>Name / Title</li>
<li>Alternate Name</li>
<li>Description</li>
<li>Microdata Type URLs</li>
<li>Same-As URLs</li>
</ul></li>
<li>Claim Review Information

<ul>
<li>Short Summary of Claim</li>
<li>First Appearance URL</li>
</ul></li>
<li>Creative Work Information

<ul>
<li>Is Part of URL</li>
<li>Headline</li>
<li>Full Text</li>
<li>Keywords</li>
<li>Language</li>
<li>Family Friendly</li>
<li>Copyright Year</li>
<li>License URL</li>
<li>Publisher</li>
<li>Service Provider</li>
</ul></li>
<li>Event Information

<ul>
<li>Event Language</li>
<li>Event Attendance</li>
<li>Event Online URL</li>
<li>Event Physical Venue</li>
<li>Event Organizer Organization</li>
<li>Event Organizer Person</li>
<li>Event Performer Organization</li>
<li>Event Performer Person</li>
<li>Event Start (date, time, timezone)</li>
<li>Event End (date, time, timezone)</li>
<li>Event Offers Start (date, time, timezone)</li>
<li>Event Offers End (date, time, timezone)</li>
<li>Event Offers (name, price, currency, availability)</li>
</ul></li>
<li>How-To

<ul>
<li>How-To Makes </li>
<li>How-To Preparation Time </li>
<li>How-To Total Time </li>
<li>How-To Supplies </li>
<li>How-To Tools </li>
<li>How-To Steps (section name, section description, step name, direction text and image)</li>
</ul></li>
<li>Job Posting Information

<ul>
<li>Job Title</li>
<li>Hiring Organization</li>
<li>Job Location</li>
<li>Base Salary</li>
<li>Employment Type</li>
<li>Jpb Posting Expires</li>
</ul></li>
<li>Movie Information

<ul>
<li>Cast Names</li>
<li>Director Names</li>
<li>Production Company</li>
<li>Movie Runtime</li>
</ul></li>
<li>Organization Information

<ul>
<li>Select an Organization</li>
</ul></li>
<li>Person Information

<ul>
<li>Select a Person</li>
</ul></li>
<li>Product Information (Additional)

<ul>
<li>Product Length (cm)</li>
<li>Product Width (cm)</li>
<li>Product Height (cm)</li>
<li>Product Depth (cm)</li>
<li>Product Volume (ml)</li>
<li>Product GTIN-14</li>
<li>Product GTIN-13/EAN</li>
<li>Product GTIN-12/UPC</li>
<li>Product GTIN-8</li>
<li>Product GTIN</li>
</ul></li>
<li>QA Page Information

<ul>
<li>QA Heading</li>
</ul></li>
<li>Recipe Information

<ul>
<li>Recipe Cuisine </li>
<li>Recipe Course </li>
<li>Recipe Makes </li>
<li>Cooking Method </li>
<li>Preparation Time </li>
<li>Cooking Time </li>
<li>Total Time </li>
<li>Recipe Ingredients </li>
<li>Recipe Instructions </li>
<li>Nutrition Information per Serving 

<ul>
<li>Serving Size</li>
<li>Calories</li>
<li>Protein</li>
<li>Fiber</li>
<li>Carbohydrates</li>
<li>Sugar</li>
<li>Sodium</li>
<li>Fat</li>
<li>Saturated Fat</li>
<li>Unsaturated Fat</li>
<li>Trans Fat</li>
<li>Cholesterol</li>
</ul></li>
</ul></li>
<li>Review Information

<ul>
<li>Review Rating </li>
<li>Rating Value Name</li>
<li>Subject of the Review

<ul>
<li>Subject Webpage Type </li>
<li>Subject Webpage URL </li>
<li>Subject Same-As URL </li>
<li>Subject Name </li>
<li>Subject Description </li>
<li>Subject Image ID or URL </li>
<li>Claim Subject Information

<ul>
<li>Short Summary of Claim</li>
<li>First Appearance URL</li>
</ul></li>
<li>Creative Work Subject Information

<ul>
<li>C.W. Author Type</li>
<li>C.W. Author Name</li>
<li>C.W. Author URL</li>
<li>C.W. Published Date</li>
<li>C.W. Created Date</li>
</ul></li>
<li>Book Subject Information

<ul>
<li>Book ISBN</li>
</ul></li>
<li>Movie Subject Information

<ul>
<li>Movie Cast Names</li>
<li>Movie Director Names</li>
</ul></li>
<li>Product Subject Information

<ul>
<li>Product Brand</li>
<li>Product Offers (name, price, currency, availability)</li>
<li>Product SKU</li>
<li>Product MPN</li>
</ul></li>
<li>Software App Subject Information

<ul>
<li>Operating System</li>
<li>Application Category</li>
<li>Software App Offers (name, price, currency, availability)</li>
</ul></li>
</ul></li>
</ul></li>
<li>Software Application Information

<ul>
<li>Operating System</li>
<li>Application Category</li>
</ul></li>
</ul></li>
</ul>

<h3>WPSSO Core Plugin Required</h3>

<p>WPSSO Schema JSON-LD Markup (aka WPSSO JSON) is an add-on for the <a href="https://wordpress.org/plugins/wpsso/">WPSSO Core plugin</a>.</p>


<h2>Installation</h2>

<h3 class="top">Install and Uninstall</h3>

<ul>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/installation/install-the-plugin/">Install the WPSSO JSON Add-on</a></li>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/installation/uninstall-the-plugin/">Uninstall the WPSSO JSON Add-on</a></li>
</ul>


<h2>Frequently Asked Questions</h2>

<h3 class="top">Frequently Asked Questions</h3>

<ul>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/faqs/can-i-add-custom-schema-properties-to-the-json-ld/">Can I add custom Schema properties to the JSON-LD?</a></li>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/faqs/how-do-i-create-a-schema-faqpage/">How do I create a Schema FAQPage?</a></li>
</ul>

<h3>Advanced Documentation and Notes</h3>

<ul>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/">Developer Resources</a>

<ul>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/filters/">Filters</a>

<ul>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/filters/all/">All Filters</a></li>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/filters/examples/">Filter Examples</a>

<ul>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/filters/examples/assign-a-custom-field-value-to-a-schema-property/">Assign a Custom Field Value to a Schema Property</a></li>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/filters/examples/exclude-schema-markup-by-post-type/">Exclude Schema Markup by Post Type</a></li>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/filters/examples/modify-the-aggregaterating-property/">Modify the aggregateRating Property</a></li>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/developer/filters/examples/modify-the-videoobject-name-and-description/">Modify the VideoObject Name and Description</a></li>
</ul></li>
</ul></li>
</ul></li>
<li><a href="https://wpsso.com/docs/plugins/wpsso-schema-json-ld/notes/schema-shortcode/">Schema Shortcode for Custom Markup</a></li>
</ul>


